package graph_algorithms;

import java.util.HashSet;
import java.util.Iterator;


public class MetaModule implements Comparable<MetaModule> {
	
	/*Members*/
	HashSet<Integer> U;
	HashSet<Integer> V;
	MetaModuleFinder dcData;
	public double betweenLLRScore;
	double betweenAvgLLRScore;
	
	HashSet<Integer> union = null;
	
	public MetaModule(HashSet<Integer> u,HashSet<Integer> v,MetaModuleFinder data) {
		U=u;
		V=v;
		dcData=data;
		betweenLLRScore=0;
		betweenAvgLLRScore=0;
		updatePairScore();
	}

	public void updatePairScore() {
		for (Iterator<Integer> iterator = V.iterator(); iterator.hasNext();) {
			Integer inV = (Integer) iterator.next();
			for (Iterator<Integer> iterator2 = U.iterator(); iterator2.hasNext();) {
				Integer inU = (Integer) iterator2.next();
				betweenLLRScore+=dcData.DC_graph[inV][inU];
			}
			
		}
		betweenAvgLLRScore = betweenLLRScore/((double)V.size()+U.size());
	}

	@Override
	public int compareTo(MetaModule o) {
		if (betweenLLRScore > o.betweenLLRScore) {
			return 1;
		}
		if (betweenLLRScore < o.betweenLLRScore) {
			return -1;
		}
		return 0;
	}
	public HashSet<Integer> getUnion() {
		if (union == null){
			union = new HashSet<Integer>();
			for (Iterator<Integer> iterator = U.iterator(); iterator.hasNext();) {
				Integer inU = (Integer) iterator.next();
				union.add(inU);
			}
			for (Iterator<Integer> iterator = V.iterator(); iterator.hasNext();) {
				Integer inV = (Integer) iterator.next();
				union.add(inV);
			}
		}
		
		return union;
	}
	
	
	
}
